var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
const cookieSession = require('cookie-session')
var logger = require('morgan');

var authRouter = require('./routes/auth.js');
var indexRouter = require('./routes/index.js');
var queueRouter = require('./routes/queue.js');
var restaurantRouter = require('./routes/restaurant.js');
var tableRouter = require('./routes/table.js');
var tableTypeRouter = require('./routes/tabletype.js');
var userRouter = require('./routes/user.js');
var staffRouter = require('./routes/staff.js');

var app = express();


app.use(cookieSession({
  name: 'session',
  keys: ['f890939e320f89c334625d1cf6714e8ca0ffc03ae1ea7fa8d2602ee622c79cf2','251bcb224d9a6118f915174f75a0df7f27c9dc760b6b8d062021c9de36da1d0d'],
  maxAge: 3600000
}))

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

app.use('/', authRouter);
app.use('/', indexRouter);
app.use('/', queueRouter);
app.use('/', restaurantRouter);
app.use('/', tableRouter);
app.use('/', tableTypeRouter);
app.use('/', userRouter);
app.use('/', staffRouter);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
