const express = require('express');
const router = express.Router();

const staffController = require("../controllers/StaffController");
const authController = require("../controllers/AuthController");

router.get('/staff', [ authController.checkAuth, authController.adminRoute ],staffController.showIndex);
router.get('/staff/create', [ authController.checkAuth, authController.adminRoute ],staffController.showCreate);
router.get('/staff/manage/:id', [ authController.checkAuth, authController.adminRoute ],staffController.showManage);
router.post('/staff/create', [ authController.checkAuth, authController.adminRoute ],staffController.createStaff);
router.post('/staff/update', [ authController.checkAuth, authController.adminRoute ],staffController.updateStaff);
router.post('/staff/delete', [ authController.checkAuth, authController.adminRoute ],staffController.deleteStaff);

// 
module.exports = router;