const express = require('express');
const router = express.Router();

const userController = require("../controllers/UserController");
const authController = require("../controllers/AuthController");

router.get('/user', [ authController.checkAuth, authController.adminRoute ],userController.showIndex);
router.get('/user/create', [ authController.checkAuth, authController.adminRoute ],userController.showCreate);
router.get('/user/manage/:id', [ authController.checkAuth, authController.adminRoute ],userController.showManage);
router.post('/user/create', [ authController.checkAuth, authController.adminRoute ],userController.createUser);
router.post('/user/update', [ authController.checkAuth, authController.adminRoute ],userController.updateUser);
router.post('/user/delete', [ authController.checkAuth, authController.adminRoute ],userController.deleteUser);

// 
module.exports = router;